global DFrExp   :label;
global DResult  :label;


extern RShift64 :label;
extern __FPIEEE_Flags       :word;
extern __FPIEEE_RoundMode   :word;


import FPIEEE_FLAGS_DEF from rtmacro;

FPIEEE_FLAGS_DEF();


begin text

<DFrExp>
    ar5 = sp;
    push ar0, gr0;
    ar0, gr0 = [ ar5 -= 4 ];    //   double
    push ar2, gr2
        with gr2 = gr0 << 1;
    gr2 >>= 21;             // 
    if <>0 delayed skip Normalized;
    ar2 = gr0    //  
        with gr0 <<= 12;
    gr0 >>= 12;             // 
    // cond. skip Normalized
    delayed skip Store
        with gr2++;
    gr7 = false;
    nul;
    // skip Normalized
<Normalized>
    gr7 = 2047;
    gr7 = 00100000h
        with gr2 - gr7;
    if =0 skip Abnormal;
    gr0 += gr7;
    gr7 = false;
<Store>
    [ar5] = ar0, gr0;
    [ --ar5 ] = gr2;
    [ --ar5 ] = ar2;
    pop ar2, gr2;
    pop ar0, gr0;
    return;
<Abnormal>
    push ar1, gr1;
    gr1 = ar0;
    with gr0 or gr1;
    if <>0 delayed skip NaN;
    with gr1 + 1;
    pop ar1, gr1;
    // cond. skip NaN;
    delayed skip Store;
    gr7 = false;
    gr7++;
    // skip Store;
<NaN>
    if <>0 delayed skip SignalingNaN;
    gr7 = 000fffffh;
    with gr0 - gr7;
    if =0 skip Store
        with gr7 = true;
<SignalingNaN>
    gr7 = [__FPIEEE_Flags];
    gr0 = _FPIEEE_Invalid;
    gr7 = gr7 or gr0;
    [__FPIEEE_Flags] = gr7
        with gr0 = false;
    delayed skip Store;
    gr7 = true;
    gr7 <<= 31;
    // skip Store;

//======  DResult ======
//  :    gr2 -   ,
//              gr1 -   ,
//              gr0 -    ,   ,
//              gr3 - ,
//              gr4 -       ,
//              gr5 - .
//  :   ar0 -  32  ,
//              gr0 -  32  .
<DResult>
    gr7 = 00100000h;
    with gr2 - gr7;
    if u< skip Smaller;

    gr7 <<= 1;  // 00200000h;
    with gr2 - gr7;
    if u< delayed skip CheckTininess
        with gr3;
    push ar6, gr6;
    with gr6 = false noflags;
    // cond. skip CheckTininess
<LLoop>
    gr2 >>= 1;
    gr1 C>>= 1;
    gr0 C>>= 1;
    gr6 C<<= 1;
    with gr2 - gr7;
    gr4 = gr4 or gr6 noflags;
    if u>= skip LLoop
        with gr3++;

<CheckTininess>
    if > delayed skip CheckExact;
    pop ar6, gr6;
    nul;
    // cond. skip CheckExact

<Tiny>  //  ,    
    gr7 = 32
        with gr3 = -gr3;
    with gr3 - gr7;
    if u>= skip Tiny32
        with gr3++;     //   

        //   1  32
    ar2 = gr1;
    push ar2, gr2;
    call RShift64
        with gr7 = gr3;
    ar1 = gr0;
    push ar1, gr1;
    call RShift64
        with gr7 = gr3;
    pop ar0, gr0
        with gr4 = gr4 or gr0;
    gr0 = ar0;
    delayed skip CheckUnderflow;
    pop ar2, gr2;
    gr1 = ar2;
    // skip CheckUnderflow;
<Tiny32>
    gr3 -= gr7;
    with gr3 - gr7;
    if u>= delayed skip Tiny64;
    ar2 = gr1;
    push ar2, gr2;
    // cond. skip Tiny64;

        //   33  63
    call RShift64
        with gr7 = gr3;
    pop ar2, gr2;    //   gr1
    gr7 = ar2;
    with gr7 and gr4;
    if =0 skip HardCase;
    delayed skip CheckUnderflow
        with gr1 = gr2;
    gr0 = gr7;
    gr2 = false;
    // skip CheckUnderflow;
<HardCase>
    gr4 = gr4 or gr1;
    gr4 = gr4 or gr0;
    delayed skip CheckUnderflow
        with gr1 = gr2;
    gr2 = false;
    gr0 = false;
    // skip CheckUnderflow;
<Tiny64>
    call RShift64
        with gr7 = gr3 - gr7;
    pop ar3, gr3;
    with gr3 and gr4;
    if <>0 skip L1;
    gr4 = gr4 or gr2;
    gr4 = gr4 or gr1;
    gr4 = gr4 or gr0;
<L1>
    gr0 = gr7;
    gr1 = false;
    gr2 = false;

<CheckUnderflow>
    gr3 = 1
        with gr0 or gr4;
    if =0 skip ResAfter;
    gr7 = [__FPIEEE_Flags];
    gr4 = _FPIEEE_Underflow;    // gr4 <> 0,     ,  
    delayed skip Round
        with gr7 = gr7 or gr4;
    [__FPIEEE_Flags] = gr7;
    // skip Round;

<Smaller>
    with gr7 = gr2 or gr1;
    with gr7 or gr0;
    if =0 delayed skip CheckExact
        with gr3 - 1;
    gr7 = 00100000h;
    // cond. skip CheckExact
<SLoop>
    if <= skip Tiny;
    gr0 <<= 1;
    gr1 C<<= 1;
    gr2 C<<= 1;
    with gr2 - gr7;
    if u< delayed skip SLoop
        with gr3--;
    with gr3 - 1;
    nul;
    // cond. skip SLoop

<CheckExact>
    with gr0 or gr4;
    if =0 skip CheckOverflow;   //  

<Round>
    gr7 = [__FPIEEE_RoundMode];
    with gr7;
    if <>0 skip R1
        with gr7--;

        // round to nearest
    gr0 <<= 1;
    if not carry skip Inexact
        with gr0 or gr4;

        //     - 
    if <>0 delayed skip InexactWithOne;
    gr1++;
    gr2 = gr2 + carry;
    // cond. skip InexactWithOne

        //  ;    
    delayed skip InexactWithOne;
    gr1 >>= 1;
    gr1 <<= 1;
    // skip InexactWithOne;

<R1>
    if =0 skip Inexact;
        // rounding toward 0 -  

    gr7--;
    if <>0 skip R3
        with gr5;

        // rounding toward +Inf
    if < skip Inexact;  //   - 
    delayed skip InexactWithOne;
    gr1++;
    gr2 = gr2 + carry;
    // cond. skip InexactWithOne

<R3>    // rounding toward -Inf
    if >= skip Inexact;  //   - 
    gr1++;
    gr2 = gr2 + carry;

<InexactWithOne>    //    
    gr7 = 00200000h;
    with gr2 - gr7;
    if <>0 skip Inexact;
    gr2 >>= 1;
    gr1 C>>= 1;
    gr3++;

<Inexact>   //  
    gr7 = [__FPIEEE_Flags];
    gr4 = _FPIEEE_Inexact;
    gr7 = gr7 or gr4;
    [__FPIEEE_Flags] = gr7;

<CheckOverflow>
    gr7 = 07ffh;
    with gr3 - gr7;
    if >= skip Overflow;

    gr7 = 00100000h;
    with gr2 - gr7;
    if u< delayed skip ResAfter;
    gr2 <<= 12;
    gr2 >>= 12;
    // cond. skip ResAfter
    gr3 <<= 20;
    gr2 = gr2 or gr3;
<ResAfter>
    delayed return
        with gr5 >>= 31;
    gr5 <<= 31;
    ar0 = gr1;
    gr0 = gr2 or gr5;
    // return;

<Overflow>
    gr7 = [__FPIEEE_Flags];
    gr4 = _FPIEEE_Overflow;
    gr2 = [__FPIEEE_RoundMode]
        with gr7 = gr7 or gr4;
    [__FPIEEE_Flags] = gr7
        with gr2;
    if <>0 delayed skip OF1
        with gr2--;
    gr0 = 7ff00000h;
    // cond. skip OF1

        // overflow with rounding to nearest
    delayed return
        with gr1 = false;
    gr5 >>= 31;
    gr5 <<= 31;
    ar0 = gr1
        with gr0 = gr0 or gr5;
    // return;

<OF1>
    if <>0 skip OF2
        with gr2--;

        //  overflow with rounding toward 0
    gr1 = true;
    gr0--;  // 7fefffffh -      double
            //  ( )
    delayed return
        with gr5 >>= 31;
    gr5 <<= 31;
    ar0 = gr1
        with gr0 = gr0 or gr5;
    nul;
    // return;

<OF2>
    if =0 delayed skip OF3
        with gr5;
    gr7 = 80000000h;

        //  overflow with rounding toward +Inf
    if >= delayed return;
    gr1 = false;
    ar0 = gr1;
    nul;
    // cond. return;
    delayed return
        with gr1 = true;
    gr0--;
    ar0 = gr1
        with gr0 = gr0 or gr7;
    nul;
    // return;

<OF3>
        //  overflow with rounding toward -Inf
    if < delayed return
        with gr0 = gr0 or gr7;
    gr1 = false;
    ar0 = gr1;
    nul;
    // return;
    delayed return;
    gr1--;
    gr0 = true;
    nul;
    // return;

end text;
