//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                              //
//                                                                          //
//                                               //
//                                           //
//                                                                          //
//                           fadd.asm                                       //
//                                                                          //
//   float .                                            //
// FAdd                                                                     //        
//                                                                          //
//////////////////////////////////////////////////////////////////////////////

// : 
// : 02 ( 27.11.97 )
// : 
// :   2    .    
//   .     .

global FAdd :label;


extern FFrExp   :label;
extern FResult  :label;
extern RShift64 :label;
extern FPIEEE_Signal :label;

import FPIEEE_FLAGS_DEF from rtmacro;

FPIEEE_FLAGS_DEF();


begin text

//=====  FAdd =================================
//     . 32- 
//    .
//  :     .
// +0 = SP    
// -1 =  , float 32 
// -2 =  , float 32 
// -3 = PSW
// -4 = PC
//
//  : gr7 - , float 32 
// : ar5
<FAdd>
        //    . ar5 -  , gr5 
    pop ar5,gr5  with gr7 = gr5;    // gr7 -   gr5
    push ar0,gr0 with gr0 = gr5;    // gr0 -  
    push ar1,gr1 with gr5 = gr7;    //    gr5
    push ar2,gr2;
    push ar3,gr3;
    push ar4,gr4;
    push ar5,gr5 with gr4 = gr0;    // gr4 -  
    gr5 = ar5;                      // gr5 -  

    push ar4, gr4;  //  FFrExp   
    call FFrExp;
    push ar5, gr5   //  FFrExp   
        with gr3 = gr7;     //   
    call FFrExp;

        
        //    
    pop ar0,gr0 with gr3 or gr7;    // ar0 - , gr0 -  
    gr1 = ar0;                      // gr1 -  

    if <>0 delayed skip Abnormal;   //      NaN
                                    //  
    pop ar2,gr2;        // gr2 -   , ar2 - 
    gr3 = ar2 with gr2 - gr0;   //  
    // cond. skip Abnormal
    if u>= skip Adjust
        with gr7 = false;

        //   ,      
        //  
    gr4 = gr5
        with gr5 = gr4;
    gr0 = gr2
        with gr2 = gr0;
    gr1 = gr3
        with gr3 = gr1;

<Adjust>    //      
    ar1 = gr7 with gr7 = gr2 - gr0;   //   -  
    push ar1,gr1;   //   RShift64
    call RShift64;
    pop ar0,gr0;    // ar0 -  , gr0 - 
    gr0 = ar0 with gr7 = gr0;   // gr7 -  , gr0 - 

    with gr7 or gr0;
    if <>0 skip Normal
        with gr4 xor gr5;

        //     
    if < skip SubAlmostZero
        with gr1;   //     ?
    delayed skip Res;
    gr1 = gr3               //  
        with gr3 = gr1;     //    
    nul;
    // skip Res;
<SubAlmostZero>
    if =0 delayed skip Res;
    gr1 = gr3               //  
        with gr3 = gr1;     //    
    nul;
    // cond. skip Res
    delayed skip Res;
    gr1--;     //    
    gr0 = false;
    // skip Res;

<Normal>    //   
    if < skip Sub;

        // 
    delayed skip Res
        with gr1 = gr3 + gr7;
    gr3 = false;
    nul;
    // skip Res;

<Sub>   // 
    gr0 = -gr0;
    gr1 = gr3 - gr7 - 1 + carry;
    if >= skip CheckZero
        with gr3 = false;

        //  ;     
    gr7 = 80000000h
        with gr0 = -gr0;
    gr1 = gr3 - gr1 - 1 + carry;
    gr4 = gr4 xor gr7;

<CheckZero>
    with gr0 or gr1;
    if <>0 skip Res;
    gr4 <<= 1;
    gr4 >>= 1;  // 0    +

<Res>
    call FResult;
<Ret>
    pop ar5,gr5;
    pop ar4,gr4;
    pop ar3,gr3;
    pop ar2,gr2;
    pop ar1,gr1;
    pop ar0,gr0;
    return;

<Abnormal>
    with gr3;
    if < skip NaN1;
    if > skip Inf1
        with gr7;
    if < skip NaN2;
<Inf2>
    gr7 = 7f800000h;
    delayed skip Ret
        with gr5 >>= 31;
    gr5 <<= 31;
    gr7 = gr7 or gr5;
    // skip Ret;
<Inf1>
    if < skip NaN2;
    if > skip TwoInf
        with gr4 xor gr5;
    gr7 = 7f800000h;
    delayed skip Ret
        with gr4 >>= 31;
    gr4 <<= 31;
    gr7 = gr7 or gr5;
<TwoInf>
    if >= skip Inf2;    //   
<Invalid>
    delayed call FPIEEE_Signal;
    gr7 = _FPIEEE_Invalid;
    // call FPIEEE_Signal;
    skip Ret
        with gr7 = true;    // quiet NaN
<NaN1>
    with gr3 + 1;
    if <>0 skip Invalid     // signaling NaN
        with gr7;
    if >= skip QuietNaN;
<NaN2>
    with gr7 + 1;
    if <>0 skip Invalid;    // signaling NaN
<QuietNaN>
    skip Ret
        with gr7 = true;

end text;

//////////////////////////////////////////////////////////////////////////////
//                                                                          //
//                         fadd.asm                               //
//                                                                          //
//////////////////////////////////////////////////////////////////////////////
