//////////////////////////////////////////////////////////////////////////
//                                                                      //
//               NeuroMatrix(r) C runtime library                       //
//                                                                      //
//  strcpy.c                                                            //
//                                                                      //
// Copyright (c) 1997-2008 RC Module                                    //
//  If this code works, it was written by Alex Ruzavin                  //
//  If not, I don't know who wrote it.                                  //
//                                                                      //
// $Revision:: 2     $      $Date:: 2/01/08 1:56p    $                  //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include <string.h>

#ifdef __cplusplus
extern "C"
#endif  // __cplusplus

#if !defined(__NM6403__) && !defined(__NM6405__)

char * strcpy (char *dest, const char *src)
{
    char * str = dest;
    while( (*str++ = *src++) );
    return dest;
}

#else		//	    ..

char * strcpy (char *, const char *)
{

	__asm{
		ar7 += 2;
		push ar0,gr0;
		push ar3,gr3;
		push ar4,gr4;
									//<12,1>

	//13:   #endif
	//14:   char * strcpy (char *dest, const char *src)
	//15:   {
	//16:       char * str = dest;

		ar0 = ar6 set;                                  //<16,18>
		gr6 = [ar0+=-5];                                  //<16,18>

	//17:       while( (*str++ = *src++) );

		ar3 = ar6 set;                                  //<17,26>
		ar4 = gr6 set;                                  //<16,18>
		ar0 = [ar3+=-6];                                  //<17,5>
//    
		gr0 = [ar0++];                                  //<17,22>
		gr3 = [ar0++] with gr0;                                  //<17,20>
	<L2>
		if =0 delayed goto L4;                                  //<17,20>
		[ar4++] = gr0 with gr3;                                  //<17,20>
		gr0 = [ar0++];                                  //<17,22>
	<L2_1>
		if <>0 delayed goto L2;                                  //<17,20>
		[ar4++] = gr3 with gr0;                                  //<17,20>
		gr3 = [ar0++];                                  //<17,22>
	<L4>
//   
	//18:       return dest;

		ar5 = gr6 set;                                  //<18,5>
		pop ar4,gr4;
		pop ar3,gr3;
		pop ar0,gr0;

		ar7 = ar6;
		pop ar6,gr6;
		return;
	}
  return 0;
}

#endif  // !defined(__NM6403__) && !defined(__NM6405__)
