//----------------------------------------------------------------
//
// NeuroChip NM6403, C runtime library
// 1997-1999 (c) RC Module Inc.
// strspn.c,
//
//----------------------------------------------------------------

#include <string.h>

#ifdef __cplusplus
extern "C"
#endif
size_t strspn(const char *s, const char *accept)
{
  register const char *p;
  register const char *a;
  register size_t count = 0;

  for (p = s; *p != '\0'; ++p)
    {
      for (a = accept; *a != '\0'; ++a)
	if (*p == *a)
	  break;
      if (*a == '\0')
	return count;
      else
	++count;
    }

  return count;
}
