//----------------------------------------------------------------
//
// NeuroChip NM6403, C runtime library
// 1997-1999 (c) RC Module Inc.
// rand.c,
//
//----------------------------------------------------------------

#include <stdlib.h>

static unsigned int next=1;

#ifdef __cplusplus
extern "C" {
#endif

    int    rand(void)
    {
            next=next*1103515245+12345;
            return (next >> 16) & 0x7fff;
    }

    void    srand(unsigned int seed)
    {
            next=seed;
    }

#ifdef __cplusplus
}   // extern "C"
#endif
